//+------------------------------------------------------------------+
//|                                             Sentinel_Revised.mq4 |
//|                                      Copyright  2008, PZig Inc. |
//+------------------------------------------------------------------+
//Coded by Kevin "Savage Pip Fiend" Eaton
//EMail -- leno_2k2@hotmail.com
//.ALWAYS for hire.
#property copyright "Copyright  2008, PZig Inc."

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 White
 
               // weights
           
extern bool flip_line_up_side_down = false;
            
double	NZDLFX = 1.0;	
				/*	GBPUSD = 1.0,
					AUDUSD = 1.0,
					USDJPY = 1.0,
					USDCHF = 1.0,
					USDCAD = 1.0;
				*/	

string pairs[1] = { "NZDLFX" };
double weights[1];

double ExtMapBuffer1[];

int totalCount = 0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicator
   int i;
   
   ArrayInitialize(weights, 0.0);
   
   //Fill the array weight values to match the pair values.
   weights[0] = NZDLFX;
/*   weights[1] = GBPUSD;
   weights[2] = AUDUSD;
   weights[3] = USDJPY;
   weights[4] = USDCHF;
   weights[5] = USDCAD;
*/
    
   //Check that we have all our pairs..
   for(i = 0; i < 1; i++)
   {
    if(!checkPair(pairs[i]))
    {
      Print("Not able to load pair "+pairs[i]+"... switching to mini mode.");
      if(!checkPair(pairs[i]+"m"))
      {
        Alert("Warning -- Not able to load "+pairs[i]+" in mini or normal mode. Results may be off.");
        weights[i] = 0;
        
      } else {
        pairs[i] = pairs[i] + "m";
        if(iBars(pairs[i],0) < totalCount || totalCount == 0)
          totalCount = iBars(pairs[i],0);
      }
    } else {
       if(iBars(pairs[i],0) < totalCount || totalCount == 0)
          totalCount = iBars(pairs[i],0);
    }
    Print("Pair ("+pairs[i]+") bars = "+iBars(pairs[i],0));
  }

  Print("Number of bars to use -- ",totalCount);
   
  IndicatorBuffers(1);

  SetIndexBuffer(0,ExtMapBuffer1);
  SetIndexLabel(0,"Sentinel");
  SetIndexStyle(0,DRAW_LINE,0,1);
  
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   double sentCalc;
   int j = 0;
   int divNumber = 0;
   
   if(totalCount <= 0)
     return(0);
   
   int limit = Bars - counted_bars;
   if(limit > totalCount) limit = totalCount;
   if(limit > 0) limit--;
   if(limit < 0) return(-1);  
   
   for(int i = limit; i >= 0; i--)
   {
     sentCalc = 0;
     divNumber = 0;
     for(j = 0; j < 1; j++)
     {
       if(weights[j] > 0)
       {

          //USD starts the string...so we minus here.
          //sentCalc += iVolume(pairs[j],0,iBarShift(pairs[j],0,Time[i])) * weights[j];

          sentCalc += iClose(pairs[j],0,iBarShift(pairs[j],0,Time[i])) * weights[j];

        divNumber++; //this little bit ONLY counts those pairs that have weighted properly
       }
     }
     
     sentCalc /= divNumber;
     
     //sentCalc now equals our Sent number for this bar.
     if (flip_line_up_side_down)
     ExtMapBuffer1[i] = -1 * sentCalc;
     else
     ExtMapBuffer1[i] =  sentCalc;
   }
   

//----
   return(0);
  }
//+------------------------------------------------------------------+

bool checkPair(string pairToCheck)
{
    
  if(iClose(pairToCheck,0,0) <= 0.0)
   return(false);
 else
   return(true);

}